local oldTime = 0;
local DMFTimer = false;
local WBT_Timer;
WBT_DMFData = {
  ["Remaining"] = 0,
  ["Start"] = 0,
  ["LastOnline"] = 0,
}

local BuffIDs = {
  [23735] = true,
  [23736] = true,
  [23737] = true,
  [23738] = true,
  [23766] = true,
  [23767] = true,
  [23768] = true,
  [23769] = true,
}

function WorldBuffTracker_HasFortuneCooldown()
  local wd = tonumber(date("%u"));
  if(wd > 1 and wd < 7 and (tonumber(date("%d"))-wd >= 10)) then WBT_DMFData["Remaining"] = 0; end
  if(WBT_DMFData["LastOnline"]) then
    if(GetServerTime() - WBT_DMFData["LastOnline"] > 43200) then
      WBT_DMFData["Remaining"] = 0;
    end
  end
  return WBT_DMFData["Remaining"] > 0;
end

function WorldBuffTracker_UpdateDMFTimer()
  if(DMFTimer) then
    local T = GetServerTime();
    local dT = T - oldTime;
    oldTime = T;
    WBT_DMFData["Remaining"] = WBT_DMFData["Remaining"] - dT;
    WBT_DMFData["LastOnline"] = T;
  end
end

function WorldBuffTracker_CreateDMFTimer()
  if(WBT_DMFData["Remaining"] > 0) then
    WBT_DMFData["Remaining"] = WBT_DMFData["Remaining"] - 2;
  else
    WBT_DMFData["Remaining"] = WorldBuffTrackerBuffCDs["4"] - 1;
    WBT_DMFData["Start"] = GetServerTime();
  end
  WorldBuffTracker_SetRemainingCD();
  oldTime = GetServerTime();
  WBT_DMFData["LastOnline"] = oldTime;
  WBT_GUI_ActivateBar(4, oldTime);
  DMFTimer = true;
  WBT_Timer = C_Timer.NewTicker(1, function()
    WorldBuffTracker_UpdateDMFTimer();
    if(WBT_DMFData["Remaining"] <= 0) then
      WBT_Timer:Cancel();
      DMFTimer = false;
      --alert
    end
  end);
end

function WorldBuffTracker_SetRemainingCD()
  for i=1,32 do
    local b,_,_,_,e,f,_,_,_,id,_ = UnitBuff("player", i);
    if(b == nil) then
      return 0;
    end
    if(BuffIDs[id]) then
      WBT_DMFData["Remaining"] = WorldBuffTrackerBuffCDs["4"] + (f-GetTime()-7200);
    end
  end
  return false;
end
