local faction = UnitFactionGroup("player");
local playerName = UnitName("player");
local realmName = GetRealmName();
IncomingBuffData = {};
local TimeToBuff = {
  ["Horde"] = {
    ["1"] = {
      ["Y0"] = 12.4,
      ["Y1"] = 7.4,
      ["Y2"] = 1;
    },
    ["2"] = {
      ["Y0"] = 31,
      ["Y1"] = 16,
      ["Y2"] = 6;
    },
    ["3"] = {
      ["Y0"] = 37,
      ["Y1"] = 14,
      ["Y2"] = 9;
    },
    ["5"] = {
      ["Y0"] = 49,
      ["Y1"] = 4;
    },
  },
  ["Alliance"] = {
    ["2"] = {
      ["Y0"] = 18,
      ["Y1"] = 16,
      ["Y2"] = 6;
    },
    ["3"] = {
      ["Y0"] = 23,
      ["Y1"] = 17,
      ["Y2"] = 9;
    },
    ["5"] = {
      ["Y0"] = 48,
      ["Y1"] = 4;
    },
  },
}

function WBT_Incoming_ClearData()
  IncomingBuffData[realmName][faction] = nil;
  --IncomingBuffData[realmName][faction]["Y1"] = 0;
  --IncomingBuffData[realmName][faction]["Y2"] = 0;
  --re-implement with lag adjustment
end

function WBT_Incoming_GetTimeToBuff(faction, id, yell)
  return TimeToBuff[faction][tostring(id)][yell];
end

function WBT_Incoming_ProcessData(id, timestamp, yell)
  id = tostring(id);
  if(tonumber(timestamp) == nil) then return false end
  if(not TimeToBuff[faction][id]) then return false end
  local t = timestamp + TimeToBuff[faction][id][yell];
  if(t > GetServerTime() and t < GetServerTime() + 50 and WBT_Incoming_GetActiveBuffIncoming() == nil) then
    local elapsed = TimeToBuff[faction][id]["Y0"] - TimeToBuff[faction][id][yell];
    WBT_Incoming_SetBarData(id, timestamp, elapsed);
    WBT_Incoming_TestActive();
    return true;
  end
end

function WBT_Incoming_GetActiveBuffIncoming()
  if(IncomingBuffData[realmName]) then
    if(IncomingBuffData[realmName][faction]) then
      local dT = IncomingBuffData[realmName][faction]["Timestamp"] + TimeToBuff[faction][IncomingBuffData[realmName][faction]["ID"]]["Y0"] - GetServerTime();
      if(dT < 0 or dT > 50) then
        WBT_Incoming_ClearData();
        return;
      end
      return IncomingBuffData[realmName][faction]["ID"];
    end
  end
end

function WBT_Incoming_SetBarData(id, timestamp, elapsed)
  IncomingBuffData[realmName] = {};
  IncomingBuffData[realmName][faction] = {};
  IncomingBuffData[realmName][faction]["ID"] = tostring(id);
  IncomingBuffData[realmName][faction]["Timestamp"] = timestamp;
  IncomingBuffData[realmName][faction]["Elapsed"] = elapsed;
end

function WBT_Incoming_TestActive()
  local id = WBT_Incoming_GetActiveBuffIncoming();
  if(id) then
    WBT_Incoming_StartProgress(id);
  end
end

function WBT_Incoming_StartProgress()
  local id = WBT_Incoming_GetActiveBuffIncoming();
  local tMin = GetTime() - (GetServerTime() - IncomingBuffData[realmName][faction]["Timestamp"]) - IncomingBuffData[realmName][faction]["Elapsed"];
  local tMax = tMin + TimeToBuff[faction][id]["Y0"];
  WBT_IncomingBar:SetMinMaxValues(tMin, tMax);
  WBT_IncomingGUI_ActivateBar(id);
  WBT_IncomingGUI_ToggleTimer(true);
end

function WBT_Incoming_SetProgress()
  local t = GetTime();
  WBT_IncomingBar:SetValue(t);
  local _, statusMax = WBT_IncomingBar:GetMinMaxValues();
  WBT_IncomingBarTime:SetText(WorldBuffTracker_TimeUntilDate(statusMax - GetTime()));
  if(t > statusMax) then
    WBT_Incoming_Stop();
  end
end

function WBT_Incoming_Stop()
  WBT_Incoming_ClearData();
  WBT_IncomingGUI_DeactivateBar();
end
