BuffGUIVars = {};

local BuffGUIEnabled = false;
local BuffGUITimer = nil;
local GUILocked = false;
local Textures = {
  ["1"] = "Interface\\Icons\\Spell_Arcane_TeleportOrgrimmar",
  ["2"] = "Interface\\Icons\\inv_misc_head_dragon_01",
  ["3"] = "Interface\\Icons\\inv_misc_head_dragon_black",
  ["4"] = "Interface\\Icons\\inv_misc_orb_02",
  --["5"] = "Interface\\Icons\\ability_creature_poison_05",
};
local GUIItems = {

};
local ActiveBars = {
};

function WBT_GUI_DeactivateBar(id)
  ActiveBars[id] = nil;
  GUIItems[id].Status:Hide();
end

function WBT_GUI_ActivateBar(id, t)
  ActiveBars[id] = true;
  GUIItems[id].Status:Show();
  local idS = tostring(id);
  local cd = WorldBuffTrackerBuffCDs[idS];
  local tStart;
  local tRemain;
  local tEnd;
  if(id ~= 4) then
    tStart = WBT_GetBuffData(idS, "Timestamp");
    tRemain = tStart + cd - t;
    tEnd = tStart + cd;
    if(BuffGUIVars.StartLabel) then
      GUIItems[id].Start:SetText(date('%H:%M:%S', tStart));
    end
  else
    tRemain = math.floor(WBT_DMFData["Remaining"]);
    WorldBuffTracker_SetRemainingCD();
    tEnd = t + tRemain;
  end
  GUIItems[id].Status:SetValue(tRemain);
  if(BuffGUIVars.EndLabel) then
    GUIItems[id].End:SetText(date('%H:%M:%S', tEnd));
  end
  if(BuffGUIVars.RemainLabel) then
    GUIItems[id].Remain:SetText(WorldBuffTracker_TimeUntilDate(tRemain));
  end
end

function WBT_GUI_TestBar(id, t)
  if(not BuffGUIEnabled) then return end
  local idS = tostring(id);
  local cd = WorldBuffTrackerBuffCDs[idS];
  local tRemain;
  if(id ~= 4) then
    tRemain = WBT_GetBuffData(idS, "Timestamp") + cd - t;
  else
    tRemain = math.floor(WBT_DMFData["Remaining"]);
  end
  if(tRemain > 1) then
    WBT_GUI_ActivateBar(id, t);
  else
    WBT_GUI_DeactivateBar(id);
  end
end

function WBT_GUI_GetBarSettings()
  local settings = {};
  if(BuffGUIVars.Scale == nil) then
    BuffGUIVars.StartLabel = false;
    BuffGUIVars.EndLabel = true;
    BuffGUIVars.RemainLabel = true;
    BuffGUIVars.Width = 240;
    BuffGUIVars.X = math.floor(((GetScreenWidth() + 260) / 2));
    BuffGUIVars.Y = math.floor(((GetScreenHeight() + 80 ) / 2));
    BuffGUIVars.Scale = 100;
  end
  if(BuffGUIVars.StartLabel and BuffGUIVars.RemainLabel and BuffGUIVars.EndLabel) then
    settings.Start = "RIGHT";
    settings.Remain = "CENTER";
    settings.End = "LEFT";
  elseif(BuffGUIVars.StartLabel and BuffGUIVars.EndLabel) then
    settings.Start = "RIGHT";
    settings.End = "LEFT";
  elseif(BuffGUIVars.RemainLabel and BuffGUIVars.EndLabel) then
    settings.Remain = "RIGHT";
    settings.End = "LEFT";
  elseif(BuffGUIVars.RemainLabel and BuffGUIVars.StartLabel) then
    settings.Start = "RIGHT";
    settings.Remain = "LEFT";
  elseif(BuffGUIVars.RemainLabel) then
    settings.Remain = "CENTER";
  elseif(BuffGUIVars.StartLabel) then
    settings.Start = "CENTER";
  elseif(BuffGUIVars.EndLabel) then
    settings.End = "CENTER";
  end
  return settings;
end

function WBT_GUI_CreateBarGUI()
  local BuffGUI = CreateFrame("Frame", "WBT_BuffGUI", UIParent);
  BuffGUIEnabled = BuffGUIVars["BarsEnabled"];
  local settings = WBT_GUI_GetBarSettings();
  BuffGUI:SetPoint("TOPRIGHT", UIParent, "BOTTOMLEFT", BuffGUIVars.X, BuffGUIVars.Y);
  BuffGUI:SetScale(BuffGUIVars["Scale"] / 100);
  BuffGUI:SetWidth(BuffGUIVars["Width"] + 20);
  BuffGUI:SetHeight(80);
  for i=1,4 do
    GUIItems[i] = {};
    GUIItems[i].Status = CreateFrame("StatusBar", nil, WBT_BuffGUI);
    --??local f = CreateFrame("StatusBar", GUIItems[i].Status, WBT_BuffGUI);
    GUIItems[i].Status:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
    GUIItems[i].Status:GetStatusBarTexture():SetVertTile(false);
    GUIItems[i].Status:GetStatusBarTexture():SetHorizTile(false);
    GUIItems[i].Status:SetWidth(BuffGUIVars.Width);
    GUIItems[i].Status:SetHeight(20);
    GUIItems[i].Status:SetPoint("TOPLEFT", "WBT_BuffGUI", "TOPLEFT",
      20,
      - 24 * (i - 1));
    GUIItems[i].Status:SetMinMaxValues(0, WorldBuffTrackerBuffCDs[tostring(i)]);
    GUIItems[i].Status:SetStatusBarColor(1, 0, 0)
    GUIItems[i].Status:SetBackdrop({
      bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
      edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 1,
      insets = { left = 0, right = 0, top = -1, bottom = -1}
      })
    GUIItems[i].Status:SetBackdropColor(0, 0, 0, 0.5);
    GUIItems[i].StatusTexture = GUIItems[i].Status:CreateTexture(nil, ARTWORK);
    GUIItems[i].StatusTexture:SetHeight(20);
    GUIItems[i].StatusTexture:SetWidth(20);
    GUIItems[i].StatusTexture:SetTexture(Textures[tostring(i)]);
    GUIItems[i].StatusTexture:SetPoint("LEFT", GUIItems[i].Status, "LEFT", -21, 0);
    if(i ~= 4 and BuffGUIVars.StartLabel) then
      GUIItems[i].Start = WBT_GUI_CreateFontString(i, settings.Start);
    end
    if(BuffGUIVars.RemainLabel) then
      GUIItems[i].Remain = WBT_GUI_CreateFontString(i, settings.Remain);
    end
    if(BuffGUIVars.EndLabel) then
      GUIItems[i].End = WBT_GUI_CreateFontString(i, settings.End);
    end
  end
  local t = GetServerTime();
  for i=1,4 do
    WBT_GUI_TestBar(i, t);
  end
  WBT_GUI_ToggleTimer(WBT_GUI_ShouldDisplay());
end

function WBT_GUI_ShouldDisplay()
  if(not BuffGUIEnabled) then return false end
  if(IsInInstance() and BuffGUIVars["HiddenInstances"]) then return false end
  return true;
end

function WBT_GUI_CreateFontString(index, justify)
  local string = GUIItems[index].Status:CreateFontString(nil);
  string:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE");
  string:SetPoint("LEFT", GUIItems[index].Status, "LEFT", 0, 0);
  string:SetWidth(BuffGUIVars.Width);
  string:SetHeight(20);
  string:SetJustifyH(justify);
  return string;
end

function WBT_GUI_ToggleTimer(enable)
  if(not BuffGUIEnabled) then return end
  if(enable) then
    if(not BuffGUITimer) then
      BuffGUITimer = C_Timer.NewTicker(1, WBT_GUI_UpdateBars);
      WBT_BuffGUI:Show();
    end
  else
    if(BuffGUITimer) then
      BuffGUITimer:Cancel();
      WBT_BuffGUI:Hide();
    end
    BuffGUITimer = nil;
  end
end

function WBT_GUI_ToggleLock(enable)
  GUILocked = enable;
  if(enable) then
    WBT_BuffGUI:SetMovable(true);
    WBT_BuffGUI:EnableMouse(true);
    WBT_BuffGUI:RegisterForDrag("LeftButton");
    WBT_BuffGUI:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background"});
    WBT_GUI_ToggleTimer(false);
    for id=1,4 do
      GUIItems[id].Status:Show();
    end
    WBT_BuffGUI:Show();
    WBT_BuffGUI:SetScript("OnDragStart", function()
      WBT_BuffGUI:StartMoving();
      end);
    WBT_BuffGUI:SetScript("OnDragStop", function()
      WBT_BuffGUI:StopMovingOrSizing();
      local x,y = WBT_BuffGUI:GetRight(), WBT_BuffGUI:GetTop();
      BuffGUIVars.X = x;
      BuffGUIVars.Y = y;
      end);
  else
    WBT_BuffGUI:SetMovable(false);
    WBT_BuffGUI:EnableMouse(false);
    WBT_BuffGUI:SetScript("OnDragStart", nil);
    WBT_BuffGUI:SetScript("OnDragStop", nil);
    WBT_BuffGUI:SetBackdrop(nil);
    WBT_GUI_ToggleTimer(WBT_GUI_ShouldDisplay());
    local x,y = WBT_BuffGUI:GetRight(), WBT_BuffGUI:GetTop();
    BuffGUIVars.X = x;
    BuffGUIVars.Y = y;
    local t = GetServerTime();
    for id=1,4 do
      WBT_GUI_TestBar(id, t);
    end
  end
end

function WBT_GUI_UpdateBar(id, t)
  local idS = tostring(id);
  local cd = WorldBuffTrackerBuffCDs[idS];
  local tStart = WBT_GetBuffData(idS, "Timestamp")
  local tRemain = tStart + cd - t;
  if(tRemain < 1) then
    WBT_GUI_DeactivateBar(id);
    return;
  end
  GUIItems[id].Status:SetValue(tRemain);
  if(BuffGUIVars.RemainLabel) then
    GUIItems[id].Remain:SetText(WorldBuffTracker_TimeUntilDate(tRemain));
  end
end

function WBT_GUI_UpdateDMF(t)
  local cd = WorldBuffTrackerBuffCDs["4"];
  WorldBuffTracker_UpdateDMFTimer();
  local tRemain = math.floor(WBT_DMFData["Remaining"]);
  if(tRemain < 1) then
    WBT_GUI_DeactivateBar(4);
    return;
  end
  GUIItems[4].Status:SetValue(tRemain);
  if(BuffGUIVars.RemainLabel) then
    GUIItems[4].Remain:SetText(WorldBuffTracker_TimeUntilDate(tRemain));
  end
end

function WBT_GUI_UpdateBars()
  local t = GetServerTime();
  for k,v in pairs(ActiveBars) do
    if(k == 4) then
      WBT_GUI_UpdateDMF(t);
    else
      WBT_GUI_UpdateBar(k, t);
    end
  end
end

function WBT_GUI_UpdateSize()
  if(BuffGUIEnabled) then
    WBT_BuffGUI:SetScale(BuffGUIVars["Scale"] / 100);
    WBT_BuffGUI:SetWidth(BuffGUIVars["Width"] + 20);
    GUIItems[1].Status:SetWidth(BuffGUIVars["Width"]);
    GUIItems[2].Status:SetWidth(BuffGUIVars["Width"]);
    GUIItems[3].Status:SetWidth(BuffGUIVars["Width"]);
    GUIItems[4].Status:SetWidth(BuffGUIVars["Width"]);
  end
end
